/*===========================================================================
 * Project         : Mandriva Linux
 * Module          : mountloop
 * File            : umountloop.c
 * Version         : $Id: umountloop.c 145743 2005-11-14 14:04:39Z tvignaud $
 * Author          : Frederic Lepied
 * Created On      : Wed Jun  5 20:57:28 2002
 *===========================================================================*/

static const char rcs_id[] = "$Id: umountloop.c 145743 2005-11-14 14:04:39Z tvignaud $";
static const char compile_id[] = "$Compile: " __FILE__ " " __DATE__ " " __TIME__ " $";

/*
 **********************************************************************
 *
 * Included files
 *
 **********************************************************************
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include "common.h"

int
main(int argc, char * argv[])
{
  uid_t		ruid = getuid();
  uid_t		euid = geteuid();
  char		*myargv[3];
  int		myargc = 0;
  
  if (argc != 2) {
    fprintf(stderr, "usage: %s <dir>\n", argv[0]);
    exit(EXIT_FAILURE);
  }
  
  if (euid != 0) {
      fprintf(stderr,"This program must be run as root or have the SUID attribute set\n");
      exit(EXIT_FAILURE);
  }

  if (setreuid(0, 0) != 0) {
    perror("setreuid");
    exit(EXIT_FAILURE);
  }

  diruidp(argv[1], ruid);

  myargv[myargc++] = "/bin/umount";
  myargv[myargc++] = argv[1];
  myargv[myargc++] = NULL;
  myargc = 0;
  
  if (mysystem(myargv, 0)) {
    exit(EXIT_FAILURE);
  }

  return EXIT_SUCCESS;
}

/*
 * Local variables:
 * mode: c
 * End:
 *
 * umountloop.c ends here
 */
